/*

      DirectSound
=================================================================

   DirectSound,    Priority.

     ,
    ""   .   
      3  5 
,       .

       ,
       . 
      .

*/





#pragma warning (disable: 4115 4201 4214 4514 4127 4702)


#if _DEBUG

  #pragma warning (disable: 4505)

#endif


#define STRICT

#include <windows.h>            //   Windows
#include <commctrl.h>           //    

#include "dsound.h"             // DirectSound 7.0

#include <math.h>               //  

#include "resource.h"           //  





//
// #########################################################################
//
// 
// 
// #########################################################################
//





#define UNREF (void)





//
// #########################################################################
//
// 
// 
// #########################################################################
//





const int SampleRate = 44100;   //   


const double SemiTone = pow (2.0, 1.0 / 12.0); //  





//
// #########################################################################
//
// 
//
// #########################################################################
//


IDirectSound *Out;              //   

IDirectSoundBuffer *Primary;    //  

IDirectSoundBuffer *First;      //    
IDirectSoundBuffer *Second;     //    
IDirectSoundBuffer *Third;      //    

HWND DlgWin;                    //   





//
// #########################################################################
//
// 
//
// #########################################################################
//





//
//    
// ==========================
//

static void Error (char *Text) {

  MessageBox (DlgWin, Text, "", MB_ICONERROR | MB_OK);

}





//
//      
// ======================================================
//

static LONG DlgMsg (int Id, UINT Msg, LPARAM lp, WPARAM wp) {

  return SendDlgItemMessage (DlgWin, Id, Msg, lp, wp);

}




//
//    
// =====================================
//

static BOOL CALLBACK DialogProc (HWND Win, UINT Msg, WPARAM wp, LPARAM lp) {

  HRESULT Res;

  switch (Msg) {





    //
    //   
    // ==============================
    //

    case WM_INITDIALOG: {

      DlgWin = Win;


      //
      //    DirectSound (  )
      //

      Res = DirectSoundCreate (NULL, &Out, NULL);

      if (Res) {

        Error ("   ");

        EndDialog (Win, 1);

        break;

      }


      //
      //    
      //

      Res = Out->SetCooperativeLevel (Win, DSSCL_PRIORITY);

      if (Res) {

        Error ("   ");

        EndDialog (Win, 2);

        break;

      }

      
      //
      //   
      //

      DSBUFFERDESC1 BD;         //    

      memset (&BD, 0, sizeof (BD));

      BD.dwSize = sizeof (BD);
      BD.dwFlags = DSBCAPS_PRIMARYBUFFER;

      Res = Out->CreateSoundBuffer ((DSBUFFERDESC *)&BD, &Primary, NULL);

      if (Res) {

        Error ("   ");

        EndDialog (Win, 3);

        break;

      }


      //
      //   
      //

      WAVEFORMATEX Fmt = {
        WAVE_FORMAT_PCM,        //  
        1,                      // 
        SampleRate,             //  
        SampleRate * 2,         //   
        2,                      //   
        16,                     //  
        0,                      //  
      };


      //
      //    
      //

      Res = Primary->SetFormat (&Fmt);

      if (Res) {

        Error ("    ");

        EndDialog (Win, 4);

        break;

      }


      //
      //      
      //

      HRSRC WaveData;

      WaveData = FindResource (
        NULL,
        (LPCTSTR)IDR_WaveData,
        (LPCTSTR)RT_RCDATA
      );


      //
      //      
      //

      BD.dwFlags = DSBCAPS_STATIC | DSBCAPS_CTRLFREQUENCY;
      BD.dwBufferBytes = SizeofResource (NULL, WaveData);
      BD.lpwfxFormat = &Fmt;

      Res = Out->CreateSoundBuffer ((DSBUFFERDESC *)&BD, &First, NULL);

      if (Res) {

        Error ("    ");

        EndDialog (Win, 5);

        break;

      }


      //
      //      
      //

      do {

        Res = Out->DuplicateSoundBuffer (First, &Second);

        if (Res) {

          break;

        }

        Res = Second->SetFrequency (DWORD (SampleRate * pow (SemiTone, 4)));

      } while (0);

      if (Res) {

        Error ("    ");

        EndDialog (Win, 6);

        break;

      }


      //
      //      
      //

      do {

        Res = Out->DuplicateSoundBuffer (First, &Third);

        if (Res) {

          break;

        }

        Res = Third->SetFrequency (DWORD (SampleRate * pow (SemiTone, 7)));

      } while (0);

      if (Res) {

        Error ("    ");

        EndDialog (Win, 7);

        break;

      }


      //
      //     
      //

      BYTE *P1, *P2;
      DWORD S1, S2;

      Res = First->Lock (
        0,
        0,
        (void **)&P1,
        &S1,
        (void **)&P2,
        &S2,
        DSBLOCK_FROMWRITECURSOR | DSBLOCK_ENTIREBUFFER
      );

      if (Res) {

        Error ("   ");

        EndDialog (Win, 8);

        break;

      }

      BYTE *WDP = (BYTE *)LoadResource (NULL, WaveData);

      memcpy (P1, WDP, S1);
      memcpy (P2, WDP + S1, S2);

      Res = First->Unlock (P1, S1, P2, S2);

      if (Res) {

        Error ("   ");

        EndDialog (Win, 9);

        break;

      }

      return TRUE;

    }





    //
    //   Windows
    // ===========================
    //

    case WM_COMMAND: {

      UINT CtrlId = LOWORD (wp);
      //UINT CtrlMsg = HIWORD (wp);
      
      switch (CtrlId) {
        

        //
        //     -     
        // =================================================================
        //

        case IDCANCEL: {

          EndDialog (DlgWin, 0);

          return TRUE;

        }
        



        //
        //    
        // ==================================
        //

        case IDC_First: {

          if (DlgMsg (IDC_First, BM_GETCHECK, 0, 0) == BST_CHECKED) {

            Res = First->Play (NULL, 0, DSBPLAY_LOOPING);

          } else {

            Res = First->Stop ();

          }

          break;
        
        }






        //
        //    
        // ==================================
        //

        case IDC_Second: {

          if (DlgMsg (IDC_Second, BM_GETCHECK, 0, 0) == BST_CHECKED) {

            Res = Second->Play (NULL, 0, DSBPLAY_LOOPING);

          } else {

            Res = Second->Stop ();

          }

          break;
        
        }






        //
        //    
        // ===================================
        //

        case IDC_Third: {

          if (DlgMsg (IDC_Third, BM_GETCHECK, 0, 0) == BST_CHECKED) {

            Res = Third->Play (NULL, 0, DSBPLAY_LOOPING);

          } else {

            Res = Third->Stop ();

          }

          break;
        
        }






      } // switch (CtrlId)

      break;





    } // WM_COMMAND





  } // switch (Msg)






  return FALSE;

  UNREF (lp);

}
      

//
//   Windows
// ========================
//

int WINAPI WinMain (
  HINSTANCE Instance,
  HINSTANCE PrevInstance,
  LPSTR Cmd,
  int CmdShow
) {

  int Result;
  

  //
  //     
  //

  InitCommonControls ();


  //
  //   
  //

  Result = DialogBox (
    Instance, 
    MAKEINTRESOURCE (IDD_Dialog),
    HWND_DESKTOP,
    DialogProc
  );


  //
  //   
  //

  if (First) {

    First->Release ();

  }

  if (Second) {

    Second->Release ();

  }

  if (Third) {

    Third->Release ();

  }

  if (Out) {

    Out->Release ();

  }

  return Result;

  UNREF (Instance, PrevInstance, Cmd, CmdShow);

}
